angular.module('app.directives', ['app.services'])
	.directive('feedCard', ['$localstorage', '$cordovaSocialSharing', feedCard]);

function feedCard($localstorage, $cordovaSocialSharing) {
    var directive = {
        link: link,
        scope: {
            feed: '='
        },
        templateUrl: 'templates/feed-detail.html',
        restrict: 'EA'
    };
    return directive;

    function link(scope, element, attrs) {
    	scope.decode = parseHtmlEntities;
    	scope.parseUrl = parseUrl;
    	scope.fav = addToFavorites;
    	scope.isFav = isFav;
    	scope.toggleFav = toggleFav;
        scope.goToUrl = goToUrl;
        scope.share = share;
        scope.getDate = getDate;

        function share(feed){
            $cordovaSocialSharing.share(feed.title, 'Longform app', null, parseUrl(feed));
        }

        function goToUrl(url) {
            window.open(url, "_system");
        }

    	function isFav(feed) {
    		var favorites = $localstorage.getObject('favorites');
    		if (!favorites.list) return false;

    		favorites = favorites.list;
    		var filter = function(obj) {
    			return obj.link === feed.link ? true : false;
    		}

    		return favorites.filter(filter).length > 0;
    	}

    	function toggleFav(feed) {
    		if (!isFav(feed))
    			addToFavorites(feed);
    		else
    			removeFromFavorites(feed);
    	}

        function getDate(dateString) {
            var date = new Date(dateString);
            return date.toLocaleString();
        }

    	function addToFavorites(feed) {
			var favorites = $localstorage.getObject('favorites');

			if (favorites.list) {
				favorites.list.push(feed);
			} else {
				favorites.list = [feed];
			}

			$localstorage.setObject('favorites', favorites);
	    }

	    function removeFromFavorites(feed) {
	    	var favorites = $localstorage.getObject('favorites');

	    	var filter = function(obj) {
	    		return obj.link === feed.link ? false : true;
	    	}

	    	favorites.list = favorites.list.filter(filter);
	    	$localstorage.setObject('favorites', favorites); 
	    }

		function parseHtmlEntities(str) {
			return str.replace(/&#([0-9]{1,4});/gi, function(match, numStr) {
			    var num = parseInt(numStr, 10); // read num as normal number
			    return String.fromCharCode(num);
			});
		}
    
	    function parseUrl(feed) {
	      	return angular.element(feed.content)[4].href || feed.link;
	    }
    }
}